#this creates a class that allows currying of functions

#this list just holds references to every created curried function
curryList = []

class curry:
    def __init__(self, func, *args, **kwargs):
        self.func = func
        self.pending = args[:]
        self.kwargs = kwargs.copy()
        curryList.append(self)

    def __call__(self, *args, **kwargs):
        if kwargs and self.kwargs:
            kw = self.kwargs.copy()
            kw.update(kwargs)
        else:
            kw = kwargs or self.kwargs

        return self.func(*(self.pending + args), **kw)
        
