
import sys, os, tempfile, time, thread, re, glob
import wizutil

#this is because all calls to os.system execute /bin/sh and sometimes
#the sandboxed libc won't work with the host /bin/sh.  We need to figure this out
os.environ["LD_LIBRARY_PATH"] = "/lib:" + os.environ["LD_LIBRARY_PATH"]


from curry import curry
from messaging import errMsg, dbgMsg, stdMsg
from qt import *

from lpfdialog import LPFDialog
from debmainwindowfrm import DebMainWindowFrm
from ecdwidget import EcdWidget, EcdController
from debutil import DebianBinaryPackage, getStatusOutput
import debutil

twlogo_xpm = [
"32 31 249 2",
"      c None",
".     c #121E09",
"+     c #111B08",
"@     c #0A1105",
"#     c #040602",
"$     c None",
"%     c #020202",
"&     c #1B2017",
"*     c #32382C",
"=     c #1D2416",
"-     c #0A1104",
";     c #040702",
">     c #10110E",
",     c #415035",
"'     c #4A6435",
")     c #415A2D",
"!     c #1A2213",
"~     c #101A08",
"{     c #0A1004",
"]     c #030401",
"^     c #090A07",
"/     c #292F23",
"(     c #2C3226",
"_     c #11190A",
":     c #080D03",
"<     c #020301",
"[     c #040403",
"}     c #445536",
"|     c #5F8740",
"1     c #487725",
"2     c #4A7828",
"3     c #15210D",
"4     c #0F1908",
"5     c #090F04",
"6     c #11140E",
"7     c #30362A",
"8     c #22291B",
"9     c #0C1406",
"0     c #060A03",
"a     c #010100",
"b     c #10130D",
"c     c #5A7841",
"d     c #4A7927",
"e     c #3A5E1F",
"f     c #000100",
"g     c #0F1807",
"h     c #080E04",
"i     c #020201",
"j     c #1C2117",
"k     c #32372C",
"l     c #192111",
"m     c #0B1205",
"n     c #181C14",
"o     c #5A7E3E",
"p     c #477625",
"q     c #477525",
"r     c #010201",
"s     c #040503",
"t     c #22281C",
"u     c #2E3428",
"v     c #141D0C",
"w     c #030501",
"x     c #151911",
"y     c #567B39",
"z     c #315119",
"A     c #14210A",
"B     c #070B03",
"C     c #111C09",
"D     c #3C631F",
"E     c #0D1607",
"F     c #060705",
"G     c #282E23",
"H     c #2A3124",
"I     c #111B09",
"J     c #0C0E0A",
"K     c #55783A",
"L     c #416B21",
"M     c #18260D",
"N     c #12160E",
"O     c #0B1306",
"P     c #487626",
"Q     c #080A06",
"R     c #2A3023",
"S     c #252D1E",
"T     c #091004",
"U     c #020401",
"V     c #020302",
"W     c #516E3A",
"X     c #3A601E",
"Y     c #232E1A",
"Z     c #3C4A2F",
"`     c #070A05",
" .    c #3B6020",
"..    c #0D1506",
"+.    c #090B07",
"@.    c #2B3225",
"#.    c #232B1C",
"$.    c #3D502E",
"%.    c #2C3922",
"&.    c #324125",
"*.    c #304B1B",
"=.    c #0B0D09",
"-.    c #2C3326",
";.    c #222A1A",
">.    c #1E2618",
",.    c #527E30",
"'.    c #3E6720",
").    c #2B3920",
"!.    c #354925",
"~.    c #2B4119",
"{.    c #2D3427",
"].    c #202919",
"^.    c #101B08",
"/.    c #050604",
"(.    c #527536",
"_.    c #457123",
":.    c #233118",
"<.    c #3F592B",
"[.    c #010200",
"}.    c #213213",
"|.    c #1F2917",
"1.    c #394C29",
"2.    c #497726",
"3.    c #203311",
"4.    c #4B6834",
"5.    c #1D2A12",
"6.    c #0B1305",
"7.    c #030602",
"8.    c #0F130C",
"9.    c #527C32",
"0.    c #304F18",
"a.    c #3C512B",
"b.    c #1B2B0E",
"c.    c #0C1009",
"d.    c #050703",
"e.    c #040603",
"f.    c #131C0C",
"g.    c #3F582B",
"h.    c #436E22",
"i.    c #1F2A16",
"j.    c #416228",
"k.    c #030502",
"l.    c #212B19",
"m.    c #131A0D",
"n.    c #12180E",
"o.    c #507C2F",
"p.    c #1E310F",
"q.    c #476530",
"r.    c #131F09",
"s.    c #28351D",
"t.    c #030402",
"u.    c #0C1107",
"v.    c #3D5629",
"w.    c #3B621E",
"x.    c #1E2817",
"y.    c #3E6123",
"z.    c #0D100A",
"A.    c #28371C",
"B.    c #040802",
"C.    c #0A0D07",
"D.    c #517B30",
"E.    c #17270C",
"F.    c #43612C",
"G.    c #1B2C0D",
"H.    c #344824",
"I.    c #304221",
"J.    c #11170D",
"K.    c #4C762C",
"L.    c #080C05",
"M.    c #3E5A28",
"N.    c #010101",
"O.    c #496E2E",
"P.    c #1C2E0E",
"Q.    c #2F4320",
"R.    c #325319",
"S.    c #222E18",
"T.    c #273F15",
"U.    c #141B0E",
"V.    c #4D7B2B",
"W.    c #426D22",
"X.    c #45682A",
"Y.    c #203510",
"Z.    c #344D21",
"`.    c #0C1108",
" +    c #060903",
".+    c #2D411E",
"++    c #2B4716",
"@+    c #4E7B2D",
"#+    c #131F0A",
"$+    c #3E6124",
"%+    c #203410",
"&+    c #262E1F",
"*+    c #0B1007",
"=+    c #426329",
"-+    c #1A2512",
";+    c #497827",
">+    c #416625",
",+    c #3B5E20",
"'+    c #040502",
")+    c #0C0D0B",
"!+    c #445337",
"~+    c #10150C",
"{+    c #1F2718",
"]+    c #4C772C",
"^+    c #447023",
"/+    c #243417",
"(+    c #0C1306",
"_+    c #36571D",
":+    c #598239",
"<+    c #56783B",
"[+    c #091005",
"}+    c #2A3520",
"|+    c #10160B",
"1+    c #4B7929",
"2+    c #34551A",
"3+    c #233514",
"4+    c #17250C",
"5+    c #33541A",
"6+    c #253C13",
"7+    c #38462D",
"8+    c #1C2812",
"9+    c #263F13",
"0+    c #1F3012",
"a+    c #3B5D21",
"b+    c #1C2018",
"c+    c #4D633B",
"d+    c #0C1008",
"e+    c #233216",
"f+    c #1D2F0F",
"g+    c #0C1307",
"h+    c #537B35",
"i+    c #5C7E40",
"j+    c #47662F",
"k+    c #080D05",
"l+    c #223214",
"m+    c #16250B",
"n+    c #395E1D",
"o+    c #1D300F",
"p+    c #1A270F",
"q+    c #19290D",
"r+    c #0A1005",
"s+    c #243A13",
"t+    c #36591C",
"u+    c #3C6220",
"v+    c #3D641F",
"w+    c #354D22",
"x+    c #0D110B",
"y+    c #0E1707",
"z+    c #161E10",
"$ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ > , ' ) ! $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ [ } | 1 1 1 2 3 $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ b c d 1 1 1 1 1 e f $ $ $ $ $ $ ",
"$ $ $ $ $ $ $ $ $ $ $ $ $ $ $ n o 1 1 1 1 p 1 1 q 0 $ $ $ $ $ $ ",
"$ $ $ $ $ $ $ $ $ $ $ $ $ $ x y 1 1 p z A B C D 1 E $ $ $ $ $ $ ",
"$ $ $ $ $ $ $ $ $ $ $ $ $ J K 1 1 L M / N $ $ O P . $ $ $ $ $ $ ",
"$ $ $ $ $ $ $ $ $ $ $ $ V W 1 1 X Y Z ` $ $ $ $  ...$ $ $ $ $ $ ",
"$ $ $ $ $ $ $ $ $ $ $ $ $.d 1 X %.&.f $ $ $ $ $ *.B $ $ $ $ $ $ ",
"$ $ $ $ $ $ $ $ $ $ $ >.,.1 '.).!.f $ $ $ $ $ $ ~.r $ $ $ $ $ $ ",
"$ $ $ $ $ $ $ $ $ $ /.(.1 _.:.<.[.$ $ $ $ $ $ $ }.$ $ $ $ $ $ $ ",
"$ $ $ $ $ $ $ $ $ $ 1.2.1 3.4.B $ $ $ $ $ $ $ $ 5.$ $ $ $ $ $ $ ",
"$ $ $ $ $ $ $ $ $ 8.9.1 0.a.b.c.d.$ $ $ $ $ $ e.f.$ $ $ $ $ $ $ ",
"$ $ $ $ $ $ $ $ $ g.1 h.i.j.k.l.$ $ $ $ $ $ $ m.a $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ $ $ n.o.1 p.q.r.s.t.$ $ $ $ $ $ $ u.$ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ $ $ v.1 w.x.y.z.A.$ $ $ $ $ $ $ f B.$ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ $ C.D.1 E.F.G.H.0 $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ $ I.1 w.J.K.L.M.$ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ N.O.1 P.Q.R.S.T.$ $ $ $ $ $ r $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ U.V.W.# X.Y.Z.P.$ $ $ $ `. +N.$ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ .+1 ++C.@+#+$+%+$ $ $ &+z.*+$ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ =+1 r.-+;+9 >+,+'+)+!+~+{+$ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ k.]+^+] /+1 (+_+1 :+<+[+}+k.$ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ |+1+2+$ 3+1 4+g 5+6+ +7+C.$ $ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ 8+2.9+$ 0+1 a+e.$ b+c+d+$ $ $ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ e+1 f+$ g+q 1 h+i+j+B $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ l+1 m+$ $ %+'.n+o+< $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ p+1 q+$ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ r+P s+$ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ t+u+a $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ @ v+w+x+V $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ ",
"$ $ $ $ $ $ $ r y+z+d.$ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ $ "]

class DebMainWindow(DebMainWindowFrm):
    def __init__(self,parent = None,name = None,fl = 0):
        DebMainWindowFrm.__init__(self,parent,name,fl)
        self.statusBar()
        self.setCaption("Debian Binary Import Tool")
        self.setPalette(QPalette(QColor(220, 220, 220)))
        self.setIcon(QPixmap(twlogo_xpm))
        
    def emitPySignal(self, pySignal, *args):
        self.emit(pySignal, args)
        
    ######################
    # get and set methods
    
    def getDebianPath(self):
        return str(self.debianPathLineEdit.text())
    def getPackageTitle(self):
        return str(self.packageTitleLineEdit.text())
    def getManPagesOption(self):
        return self.manPagesCheckBox.isChecked()
    def getInfoPagesOption(self):
        return self.infoPagesCheckBox.isChecked()
    def getIncludeDocumentationOption(self):
        return self.documentationCheckBox.isChecked()
    def getLocalesOption(self):
        return self.localesCheckBox.isChecked()
    def getPackageLocationOption(self):
        return str(self.debianPathLineEdit.text())
        
    def setDebianScripts(self, scriptNames):
        for scriptName in scriptNames:
            self.debianScriptListBox.insertItem(scriptName)
        self.debianScriptListBox.setCurrentItem(0)
            
    ######################
    # slots
    
    def browsePushButtonClicked(self):
        done = 0
        while not done:
            filename = QFileDialog.getOpenFileName( os.getcwd(), "*.deb", self, "DebianPackageSelector", "Select Debian Package File (.deb)")
            filename = str(filename).strip()
            if filename == "":
                return
            filename = os.path.abspath(os.path.expanduser(filename))
            if not os.path.exists(filename):
                status = QMessageBox.critical(self, "Bad Filename", """<qt>
                The filename you specified <b>%s</b> does not exist.  Would you like to select another file
                or cancel?</qt>""" % filename, "&Select File", "&Cancel", None, 0, 1)
                if status == 0:
                    continue
                if status == 1:
                    break
            self.debianPathLineEdit.setText(filename)
            done = 1                                    
            


######## misc functions to fix qt2.x stuff #######

qtVersion = int(str(qVersion()).replace(".", ""))
if qtVersion < 300:
 
    Qt.DockTop = QMainWindow.Top
    
    
def isPackageInProject(packageName, projectPath):
    "Check to see if a given package is installed"
    for directory in ["local", "board", "generic"]:
        if os.path.exists(projectPath + "/config-data/ecds/%s/%s.ecd" % (directory, packageName)):
            return 1
    return 0
    
def isPackageInBoard(packageName, bspPath):
    "Check to see if a given package is installed"
    if os.path.exists(bspPath + "/config-data/ecds/%s.ecd" % packageName):
        return 1
    return 0

def debSupportPath():
    for path in sys.path:
        dbgMsg("checking in path", os.path.join(path, "debsupport*.lpf"))
        globs = glob.glob(os.path.join(path, "debsupport*.lpf"))
        if len(globs):
            return globs[-1]
    return ""        

class DebMainController(QObject):
    def __init__(self, debMainWindow):
        QObject.__init__(self, None, "DebMainWindow")
        
        self.ecdController = EcdController(debMainWindow.ecdWidget)
        self.debMainWindow = debMainWindow
        QObject.connect(self.debMainWindow, PYSIGNAL("importPushButtonClicked"), self.slotImport)
        QObject.connect(self.debMainWindow, PYSIGNAL("exportPushButtonClicked"), self.slotExport)
        QObject.connect(self.debMainWindow, PYSIGNAL("debianScriptItemSelected"), self.slotDebianScriptSelected)
        QObject.connect(self.debMainWindow, PYSIGNAL("debianScriptTextChanged"), self.slotDebianScriptModified)
        QObject.connect(self.debMainWindow, PYSIGNAL("aboutActionActivated"), self.slotAboutAction)
        QObject.connect(self.debMainWindow.fileExitAction, SIGNAL("activated()"), qApp.quit)
        self.tempDir = ""
        self.debug = 0
        self.threadDone = 0
        self.dbp = None
        
        
    def importThread(self, options):
        #create the ecd path and write the ecd
        self.ecdPath = os.path.join(self.tempDir, self.dbp.getEcdFileName())
        self.dbp.writeEcdFile(self.tempDir, options, self.debMainWindow.getPackageTitle())

        #read in the ecd for the package                
        self.ecdController.readEcd(self.ecdPath)
        self.debianScripts = self.getDebianScripts()
        
        self.threadDone = 1

        
        
    def slotImport(self):
        dbgMsg("import clicked")
        
        if self.dbp != None:
            del self.dbp
            self.debMainWindow.debianScriptListBox.clear()
           
            
        
        debPath = self.debMainWindow.getDebianPath()
        self.debFileName = os.path.basename(debPath).strip()
        if debPath == "" or not os.path.exists(debPath):
            QMessageBox.critical(self.debMainWindow, "Invalid Debian Package Path", """<qt>The path that
                has been entered to the desired debian package is either invalid or non-existent.  Please
                enter a valid path and select to import again. </qt>""")
            return
              
        self.dbp = DebianBinaryPackage(debPath) 
       
        #we'll put all of our stuff in this directory until we export to an lpf or project
        self.tempDir = tempfile.mktemp()
        status, output = getStatusOutput("mkdir -p %s" % self.tempDir)
                
        #determine which options to create in the ecd
        options = []
        if self.debMainWindow.getManPagesOption():
            options.append("man")
        if self.debMainWindow.getInfoPagesOption():
            options.append("info")
        if self.debMainWindow.getIncludeDocumentationOption():
            options.append("doc")
        if self.debMainWindow.getLocalesOption():
            options.append("locale")
            
        self.threadDone = 0
        
        self.threadBox = BusyThreadClass(self.debMainWindow, self.importThread, options)
        self.threadBox.start("Importing", "Importing Debian Package " + self.dbp.fileName)
        
        
        while not self.threadDone:
            time.sleep(.5)            
            self.threadBox.doStep()
            dbgMsg("Thread not done")
            
        dbgMsg("Thread done")            
        self.threadBox.close()            
        
        QMessageBox.information(self.debMainWindow, "Import Successful", """<qt>
        The package %s has successfully been imported.  Please make any desired changes to the
        package and then select <b>Export Embedix Package</b> when finished to complete the creation
        of the embedix SDK package.</qt>""" % self.dbp.fileName)        
            
        self.modifiedScripts = []        
        self.debMainWindow.setDebianScripts(self.debianScripts.keys())
        
    def slotAboutAction(self):
        QMessageBox.about(self.debMainWindow, "About debimport", """<qt>
        <center>debimport is a Debian Package to Embedix SDK Package conversion tool.<br>
        Copyright 2002 by Lineo, Inc.</center></qt>""")
        
    
    
    def slotExport(self):
        """This is called when the user clicks on the export button.  It checks the radio buttons to see
        what type of export we need to do and then does it"""
        if self.dbp == None:
            QMessageBox.warning(self.debMainWindow, "No Package To Export", """<qt>
            You have selected to export the current package, but no debian package has
            been imported yet.  Please import a debian package before attempting to export
            an Embedix SDK package.</qt>""")
            return
            
        #stuff to do if they select to install it in a project directory
        if self.debMainWindow.projectDirectoryRadioButton.isOn():
            projectPath = str(self.debMainWindow.packagePathLineEdit.text())
            if not debutil.isProjectDir(projectPath):
                 #we should also check the architecture of the project and the package
                QMessageBox.warning(self.debMainWindow, "Bad Project Directory", """<qt>
                The project directory that you specified either does not exist or is not a valid 
                Embedix SDK project directory.  Please enter a valid project directory and click Export
                to export and SDK package.</qt>""")
                return
                
            debArch = debutil.archMappings.get(self.dbp.getControlField("architecture"), "unknown")
            projectArch = wizutil.parse_config(projectPath + "/config-data/buildcontrol/board/bsp_config")["arch"].strip()
            
            if not (debArch == "all" or debArch == projectArch):
                QMessageBox.critical(self.debMainWindow, "Wrong Architecture", """<qt>
                The imported debian package is for the %s architecture and the project directory
                specified is for the %s architecture.  Please specify a project directory for a
                project of the correct architecture or import a debian package of the correct architecture
                of the project.</qt>""" % (debArch, projectArch) )
                return             
                
            if not isPackageInProject("debsupport", projectPath):
                answer = QMessageBox.information(self.debMainWindow, "debsupport Package not Installed", """<qt>
                The debsupport package, which is needed for the %(name)s package to work correctly is not installed
                in this project.  Would you like to install it along with %(name)s?  If you do not install the debsupport
                package, %(name)s may not work correctly</qt>""" % {"name": self.dbp.getName()}, QMessageBox.Yes, QMessageBox.No)
            
                #if they answered yes
                dbgMsg("answer is", answer)
                if answer == QMessageBox.Yes:                    
                    #install the debsupport lpf into the project
                    tempDir = tempfile.mktemp().replace("@", "proc")
                    debsupportPath = debSupportPath()
                    command = """
                    set -e
                    mkdir %(tempDir)s
		    cd %(tempDir)s
                    tar zxvf %(debsupportPath)s
                    cp debsupport.ecd %(projectPath)s/config-data/ecds/local
                    cp debsupport.lbc %(projectPath)s/config-data/buildcontrol/local
                    cp debsupport.tgz %(projectPath)s/Packages/local
		    cd
                    rm -rf %(tempDir)s
                    """ % locals()

                    dbgMsg("command is\n" + command)
                    (status, output) = getStatusOutput(command)
                    if status != 0:
                        QMessageBox.warning(self.debMainWindow, "Error installing debsupport", """<qt>There was an
                        error installing the debsupport package.  Here is the output of the script.  Please contact
                        Lineo support for assistance.<br><pre>%s</pre></qt>""" % output)

                        
            ecdPath = os.path.join(projectPath, "config-data/ecds/local/", self.dbp.getEcdFileName())
            lbcPath = os.path.join(projectPath, "config-data/buildcontrol/local/")
            packagePath = os.path.join(projectPath, "Packages/local/")
            
            self.ecdController.writeEcd(ecdPath)
            self.dbp.writeLBCFile(lbcPath)            
            self.dbp.makeTarFile(packagePath, self.debianScripts.get("preinst", ""), self.debianScripts.get("postinst", ""))
            QMessageBox.information(self.debMainWindow, "Export Successful", """<qt>The debian %s package has been successfully
            exported as an SDK Embedix package to the project located at %s.  If you already have this project open
            in Target Wizard, select the menu item <b>Project-&gt;Open Recent Project</b> and select the current project to 
            reload it.  The package will be located under the node <b>Debian Packages</b> in Target Wizard's node 
            view.</qt>""" % (self.dbp.getName(), projectPath) )
        
        #stuff to do if they select to install it in a board directory
        if self.debMainWindow.boardDirectoryRadioButton.isOn():
            #check to see that we are really root
            if os.getuid() != 0:
                QMessageBox.warning(self.debMainWindow, "Must Have Root Access", """<qt>
                In order to install packages into a board directory, this application must
                have root privileges.  Please close this application and run it as root
                in order to install the specified package into a board directory.</qt>""")
                return
        
        
            boardPath = str(self.debMainWindow.packagePathLineEdit.text())
            if not os.path.exists(boardPath + "/config-data/buildcontrol/bsp_config"):
                 #we should also check the architecture of the project and the package
                QMessageBox.warning(self.debMainWindow, "Bad Board Directory", """<qt>
                The board directory that you specified either does not exist or is not a valid 
                Embedix SDK board directory.  Please enter a valid board directory and click Export
                to export and SDK package.  Most of the time these directories will be located in the
                /opt/Embedix/bsp/ directory</qt>""")
                return
                
            debArch = debutil.archMappings.get(self.dbp.getControlField("architecture"), "unknown")
            boardArch = wizutil.parse_config(boardPath + "/config-data/buildcontrol/bsp_config")["arch"].strip()
            
            if not (debArch == "all" or debArch == boardArch):
                QMessageBox.critical(self.debMainWindow, "Wrong Architecture", """<qt>
                The imported debian package is for the %s architecture and the board directory
                specified is for the %s architecture.  Please specify a board directory for a
                BSP of the correct architecture or import a debian package of the correct architecture
                of the project.</qt>""" % (debArch, boardArch) )
                return 
                
            if not isPackageInBoard("debsupport", boardPath):
                answer = QMessageBox.information(self.debMainWindow, "debsupport Package not Installed", """<qt>
                The debsupport package, which is needed for the %(name)s package to work correctly is not installed
                in this board directory.  Would you like to install it along with %(name)s?  If you do not install the debsupport
                package, %(name)s may not work correctly</qt>""" % {"name": self.dbp.getName()}, QMessageBox.Yes, QMessageBox.No)
            
                #if they answered yes
                dbgMsg("answer is", answer)
                if answer == QMessageBox.Yes:                    
                    #install the debsupport lpf into the project
                    tempDir = tempfile.mktemp().replace("@", "proc")
                    debsupportPath = debSupportPath()
                    command = """
                    set -e
                    mkdir %(tempDir)s
                    tar zxvf %(debsupportPath)s
                    cp debsupport.ecd %(boardPath)s/config-data/ecds/
                    cp debsupport.lbc %(boardPath)s/config-data/buildcontrol/
                    cp debsupport.tgz %(boardPath)s/Packages/
                    rm -rf %(tempDir)s
                    """ % locals()

                    dbgMsg("command is\n" + command)
                    (status, output) = getStatusOutput(command)
                    if status != 0:
                        QMessageBox.warning(self.debMainWindow, "Error installing debsupport", """<qt>There was an
                        error installing the debsupport package.  Here is the output of the script.  Please contact
                        Lineo support for assistance.<br><pre>%s</pre></qt>""" % output)               
            
            ecdPath = os.path.join(boardPath, "config-data/ecds/", self.dbp.getEcdFileName())
            lbcPath = os.path.join(boardPath, "config-data/buildcontrol/")
            packagePath = os.path.join(boardPath, "Packages/")
            
            self.ecdController.writeEcd(ecdPath)
            self.dbp.writeLBCFile(lbcPath)            
            self.dbp.makeTarFile(packagePath, self.debianScripts.get("preinst", ""), self.debianScripts.get("postinst", ""))    
            QMessageBox.information(self.debMainWindow, "Export Successful", """<qt>The debian %s package has been successfully
            exported as an SDK Embedix package to the project located at %s.  If you already have this project open
            in Target Wizard, select the menu item <b>Project->Open Recent Project</b> and select the current project to 
            reload it.  The package will be located under the node <b>Debian Packages</b> in Target Wizard's node 
            view.</qt>""" % (self.dbp.getName(), boardPath))        
        
        
        #stuff to do if they select to install it in a board directory
        if self.debMainWindow.lpfRadioButton.isOn():
            lpfPath = str(self.debMainWindow.packagePathLineEdit.text())
            if not os.path.isdir(lpfPath):            
                 #we should also check the architecture of the project and the package
                QMessageBox.warning(self.debMainWindow, "Bad Directory", """<qt>
                The lpf directory that you specified does not exist.  Please specify a directory location
                that is valid.</qt>""")
                return
                
            version = ""
            revision = ""
            
            pcfDict = {}
            pcfDict["type"] = "EMBEDIX PACKAGE"
            pcfDict["package_name"] = self.dbp.getName()
            pcfFileName = self.dbp.getName() + ".pcf"
            
            deb_re=re.compile(r".*_(?P<version>[\.0-9]*)-(?P<revision>[0-9]*).*")
            m = deb_re.match(self.debFileName)
            
            if m != None:
                version = m.groupdict("")["version"]
                revision = m.groupdict("")["revision"]
            
            lpfDialog = LPFDialog(self.debMainWindow, "lpf dialog", modal=1)
            lpfDialog.versionLineEdit.setText(version)
            lpfDialog.revisionLineEdit.setText(revision)
            status = lpfDialog.exec_loop()
            if status == lpfDialog.Rejected:
                return
            pcfDict["version"] = str(lpfDialog.versionLineEdit.text()).strip()
            pcfDict["revision"] = str(lpfDialog.revisionLineEdit.text()).strip()
            pcfDict["vendor"] = str(lpfDialog.vendorLineEdit.text()).strip()
            pcfDict["support_contact"] = str(lpfDialog.supportContactLineEdit.text()).strip()
                           
            debArch = debutil.archMappings.get(self.dbp.getControlField("architecture"), "unknown")
            
            tempDir = tempfile.mktemp()
            dbgMsg("temporary directory is", tempDir)
            (status, output) = getStatusOutput("mkdir -p %s" % tempDir)
            
            ecdFileName = self.dbp.getEcdFileName()
            pcfDict["config"] = ecdFileName
            lbcFileName = self.dbp.getLBCFileName()
            pcfDict["build_control"] = lbcFileName
            pcfDict["install_scope"] = "GLOBAL_SCOPE"
            pcfDict["source"] = self.dbp.getTarFileName()
            
            #this tag is required in order to work and 2.3 is the current version as of 7/2/02
            pcfDict["min_update_wizard_version"] = "2.3"
            
            pcfDict["all_files"] = pcfDict["config"] + "\n" + pcfDict["build_control"] + "\n" + pcfDict["source"] + "\n" + pcfFileName
            
            wizutil.write_config(tempDir + "/" + pcfFileName, pcfDict, pcfDict.keys())
            
            dbgMsg("pcf dictionary is:", pcfDict)
                                               
            self.ecdController.writeEcd(tempDir + "/" + ecdFileName)
            self.dbp.writeLBCFile(tempDir)            
            self.dbp.makeTarFile(tempDir, self.debianScripts.get("preinst", ""), self.debianScripts.get("postinst", "")) 
            
            ### now that all files have been created (pcf, ecd, lbc, tarball), create the lpf file and put it where it needs to go
            lpfFileName = self.dbp.getName() + "-" + version + "-" + revision + ".lpf"
            
            command = """
                cd %(tempDir)s
                tar zcvf %(lpfFileName)s *.ecd *.lbc *.tar.gz *.tgz *.pcf
                cp %(lpfFileName)s %(lpfPath)s
                """ % locals()
                
            dbgMsg("command is", command)
            
            (status, output) = getStatusOutput(command)               
            
            if status != 0:
                QMessageBox.critical(self.debMainWindow, "Error During Export", """<qt>There was an error
                during the creation of the LPF.  Here is the output of the command.<br>
                <pre>%s</pre></qt>""" % output)            
            
            QMessageBox.information(self.debMainWindow, "Export Successful", """<qt>The debian %s package has been successfully
            exported as an SDK Embedix LPF named %s in the %s directory.  You may install this into any project
            by using the Update Wizard on the lpf.  Note that this package is intended for the %s architecture and 
            will not work with projects of other architectures.  In order for this package to work correctly in a project,
            the debsupport lpf must also be installed using Update Wizard.  This lpf can be found at: %s </qt>""" % (self.dbp.getName(), lpfFileName, lpfPath, debArch, debSupportPath()))        
        
    def slotDebianScriptModified(self):
        scriptName = self.debMainWindow.debianScriptListBox.currentText()
        scriptName = str(scriptName).strip()
        
        dbgMsg(scriptName, "modified")
        
        self.debianScripts[scriptName] = str(self.debMainWindow.debianScriptLineEdit.text())
            
        
    def slotDebianScriptSelected(self, scriptName):
        dbgMsg( scriptName, "selected")
        self.debMainWindow.debianScriptLineEdit.setText(self.debianScripts.get(str(scriptName), "a"))
                
    #return a dictionary of install scripts for the debian package    
    def getDebianScripts(self):
        scriptNames = ["postinst", "preinst"]
        scriptDict = {}
        for scriptName in scriptNames:
            text = self.dbp.getFileText("control/" + scriptName)
            if text != "":
                buildVarText = "\n"
                for buildVar in ["INCLUDE_DOC", "INCLUDE_MAN", "INCLUDE_LOCALE", "INCLUDE_INFO"]:
                    buildVarText += buildVar + "=@" + buildVar + "@\n"
                text = text.replace("\n", buildVarText, 1)
                
                scriptDict[scriptName] = text
                
        return scriptDict
        
            
       
    def __del__(self):
        #directories that were used.
        dbgMsg( "being called")
        if not os.path.exists(self.tempDir):
            return

        #if we're debugging then don't remove the temporary directories
        if self.debug:
            print "not removing temporary directories located at %s" % self.tempDir
            return

        #print "dirpath is %s, tmp path is %s" % (self.dirPath, tmpPath)
        print "removing temporary directories...",
        (status, output) = getStatusOutput("\nrm -rf %s" % self.tempDir)
        if status == 0:
            print "success"
        else:
            print "failed"
            print "there may be remnant temporary directories located at %s" % self.tempDir
            
            
class BusyThreadClass:
    busy_strings = ["Working  |", "Working  /", "Working  -", "Working  \\"]
    def __init__(self, parent, function, *args):
        self.parent = parent
        self.function = function
        self.args = args
        
    def start(self, caption, message):
        thread.start_new_thread(self.function, self.args)
        self.dialog = QDialog(self.parent, "busy box", 0)
        self.dialog.setCaption(caption)
        self.message_string = "<qt>" + message + "</qt>"
        self.vl = QVBoxLayout()
        self.label = QLabel(self.message_string, self.dialog)
        self.vl.addWidget(self.label)
        
        self.busy_i = 0
        self.busy_label = QLabel(self.busy_strings[self.busy_i], self.dialog)
        self.vl.addWidget(self.busy_label)

        #do some spacing stuff
        self.vl.addSpacing(20)
        self.hl = QHBoxLayout(self.dialog)
        self.hl.addSpacing(10)
        self.hl.addLayout(self.vl)
        self.hl.addSpacing(10)
        self.hl.activate()

        self.dialog.resize(200, 100)
        self.done = 0
        self.e_num = 0
        self.dialog.show()

    def doStep(self):
        #show the next string
        self.busy_i = (self.busy_i + 1) % 4
        self.busy_label.setText(self.busy_strings[self.busy_i])
        qApp.processEvents()
  
        
    def setMessage(self, message):
        pass
        
    def close(self):
        self.dialog.done = 1
        self.dialog.close(1)
        
    
#this function will parse the argument list
def parseOptions(arg_list, option_dict):
    """Parse arguments from the commands line into dictionary form, when this function returns, the recognized
    options and values will be taken out of the arg_list"""
    #the option dictionary should look like this with keys and possible options
    #the "value_options" key lists the options that expect values directly after them
    
    #option_dict = {}
    #option_dict["help"] = ("-h", "--help")
    #option_dict["dir"] = ("-d", "--projdir", "--projectdir")
    #option_dict["lpf"] = ("-l", "--lpf")
    #option_dict["ecd"] = ("-e", "--ecd")
    #option_dict["tar"] = ("-t", "--tar")
    #option_dict["lbc"] = ("--lbc",)
    #option_dict["value_options"] = ("dir",)

    #list of options that take values after them
    value_options = option_dict["value_options"]
    arg_dict = {}
    status_flag = 1
    i = 0
    arg_list_copy = arg_list[:]
    #print "arglist", arg_list_copy
    while i < len(arg_list_copy):
        ate_arg = 0
        #print "dict", arg_dict, "argument", arg_list_copy[i]
        for key in option_dict.keys():
            arg = arg_list_copy[i]
            if arg in option_dict[key]:
                ate_arg = 1 #eat (deal with) the arguments
                
                arg_list.remove(arg) #remove this item from the list
                
                #if this argument is already in the dictionary then
                #tell the user
                if key in arg_dict.keys():
                    status_flag = 0
                    print "duplicate argument:", arg
                    break
                #if this option expects a following arg then look for it
                #and throw an error otherwise
                value = 1
                if key in value_options:
                    if i+1 < len(arg_list_copy) and arg_list_copy[i+1][0] != "-":
                        i = i + 1
                        value = arg_list_copy[i]
                        arg_list.remove(value)        
                    else:
                        status_flag = 0
                        print "Error: no value given for option", arg
                arg_dict[key] = value
                break
        #if we never ate the argument then tell the user
        if ate_arg == 0:
            status_flag = 0
            print "Unrecognized option:", arg
        i = i + 1
    return (status_flag, arg_dict)

def printOptions():
    optionText = """
Usage: debimport [OPTION]...
  
  -h, --help                show this screen
  -p DEB, --package DEB     Come up with the debian package specified already entered as the 
                            package to import.
  -d DIR, --projdir DIR     Come up with the project directory specified as the export location
                            This must be a TW project directory.
  -b DIR, --bspdir DIR      Come up with the bsp directory specified as the export location
                            This must be a TW bsp directory and to work, debimport must be invoked
                            with root permissions.
  -l DIR, --lpf DIR         Come up set to export as an lpf into the specified directory
  --batch                   Operate in batch mode with no gui interaction required.
   
Any combination of options may be given provided that each option
be given at most only once.

DEBIAN_FILE should be a normal binary debian package of the form
<name>[_<version>]-<debian release>.deb an example would be:
foo_1.0-12.deb

if the following command were given:

debimport -d /home/chrisb/project/intel -p foo_1.0-12.deb

Then the debimport tool would come up with the debian package filled in with
foo_1.0-12.deb, the export radio group would be set to be a project directory
and the project path line would be /home/chrisb/project/intel.

report bugs to <chrisb@lineo.com>

"""
    optionText = optionText.strip() + "\n"
    print optionText

optionDict = {}
optionDict["help"] = ("-h", "--help")
optionDict["dir"] = ("-d", "--projdir", "--projectdir")
optionDict["lpf"] = ("-l", "--lpf")
optionDict["bsp"] = ("-b", "--bsp")
optionDict["deb"] = ("-p", "--package")
optionDict["batch"] = ("--batch",)
optionDict["debug"] = ("--debug",)
optionDict["value_options"] = ("dir", "lpf", "bsp", "deb")

def errorMessage(message):
        sys.stderr.write("debimport: " + message + "\n")
        sys.stderr.write("try 'debimport --help' for more information\n")


def checkStartupCommandLine(controller):
        program, optionList = sys.argv[0], sys.argv[1:]
        (status, options) = parseOptions(optionList, optionDict)
        dbgMsg(options)
        if options.has_key("help"):
                printOptions()
                return 0
        if status == 0:
                errorMessage("bad options")
                return 0
        #make sure that we only had one of "dir", "lpf" and "bsp"
        if (options.has_key("lpf") + options.has_key("bsp") + options.has_key("dir")) > 1:
            errorMessage("You may only specify one of the options --lpf, --bsp, or --dir")
            return 0
        if options.has_key("lpf"):
            controller.debMainWindow.packagePathLineEdit.setText(options["lpf"])
            controller.debMainWindow.lpfRadioButton.setChecked(1)
        if options.has_key("dir"):
            controller.debMainWindow.packagePathLineEdit.setText(options["dir"])
            controller.debMainWindow.projectDirectoryRadioButton.setChecked(1)
        if options.has_key("bsp"):
            controller.debMainWindow.packagePathLineEdit.setText(options["bsp"])
            controller.debMainWindow.boardDirectoryRadioButton.setChecked(1)
        if options.has_key("deb"):
            controller.debMainWindow.debianPathLineEdit.setText(options["deb"])                          
            
        return 1
       
        
if __name__ == "__main__":
    a = QApplication(sys.argv)
    QObject.connect(a,SIGNAL("lastWindowClosed()"),a,SLOT("quit()"))
    window = DebMainWindow()
    controller = DebMainController(window)
    
    status = checkStartupCommandLine(controller)
    if not status:
        sys.exit(1)
    
    a.setMainWidget(window)
    window.show()
    a.exec_loop()
    del controller

    
